/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#ifndef BITGTKBUFFERLIST_H
#define BITGTKBUFFERLIST_H

#include <gtkmm.h>
#include <map>

#include <bit/recordbuffer.h>

namespace bitGtk {

  /**
  @author Rick L. Vinyard, Jr.
  */
  class BufferList : public Gtk::EventBox
    {
    public:
      BufferList();

      ~BufferList();

      void set_buffer(bit::RecordBuffer& buffer);

      void enable_tooltips(bool b=true);

    protected:
      bit::RecordBuffer* m_buffer;
      Gtk::Table* m_table;
      std::map< bit::FieldBase::pointer, Gtk::Label*> m_value_label;
      unsigned int m_value_label_left;
      Gtk::Tooltips m_tooltips;

      void on_record_changed();
      void on_field_value_changed( bit::FieldBuffer fieldbuffer );
      void set_field_value( bit::FieldBase::pointer field );
      void load_all_field_values();
      void load_all_field_values( bit::FieldBase::pointer );

      void create_table();
      void setup_table();
      unsigned int add_field_label(bit::FieldBase::pointer fb, unsigned int row=0, unsigned int depth=0);
      unsigned int add_field_value_label(bit::FieldBase::pointer fb, unsigned int row=0);

    };

}

#endif
